
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <io.h>
#include <time.h>
#include <conio.h>

#define BUFF_LEN 1200
#define DT_STR_LEN 100


int main(int nargs, char **args) {
  
  
  FILE *fin, *fout;
  char *fname, *fname_out;

  int ln_cnt, dt_cnt;
  int garbage_cnt;
  int quiet, debug, trail_num;
  int i;

  fin = fout = NULL;



  if (nargs < 3) {
    printf("\n\nsd_translate (%s %s) from : http:\\\\www.dideas.com\n",__DATE__,__TIME__);

    printf("Usage : sd_translate <options> [input file name] [output file name] \n");

    printf("Reads the SD (encoded) datalogger timing file and writes it a an ASC-II format\n");
    printf("options: \n");
    printf("-q enable quiet mode\n");
    printf("-d enable debug level 1 (keypress stops) \n");
    printf("-D enable debug level 2 (no action at this time)\n");
    printf("-N add a trailing number to the end of each sequence\n");
    return -1;
  }

  quiet = 0;
  debug = 0;
  trail_num = 0;
  for(i=1;i<nargs-2;i++) {
    char ch;
    ch = *args[i];
    if (ch != '-') break;
    switch(args[i][1]) {
    case 'q' : 
      quiet = 1;
      break;
    case 'd' :
      debug = 1;
      break;
    case 'D' :
      debug = 2;
      break;
    case 'N' :
      trail_num = 1;
      break;
    }
  }

  fname = args[i];
  fname_out = args[i+1];

  printf("sd_translate %s %s : %s %s\n",fname, fname_out,__DATE__, __TIME__);


  fin = fopen(fname, "r");
  if (!fin) {
    printf("Can not read %s\n", fname);
    return -1;
  }
  
#if 1
  fout = fopen(fname_out, "w");
  
  if (!fout) {
    printf("Can not write %s\n", fname_out);
    fclose(fin);
    return -2;
  }
#endif

  ln_cnt  = 0 ;
  dt_cnt = 0;
  garbage_cnt = 0;

  if (fout) {
    time_t ltime;
    fprintf(fout, "# sd_translate built : %s %s\n",__DATE__, __TIME__);
    time(&ltime);
    fprintf(fout, "# run on %s\n",ctime( &ltime));
  }


  while(!feof(fin)) {
    char star, *p, buff[BUFF_LEN];
    char dt_str[DT_STR_LEN], last_dt_str[DT_STR_LEN];
    int cpu_freq, pulse_cnt;
    int n, char_cnt,str_pos;
    long interval;


    if (garbage_cnt > 30) break;
    if (debug && kbhit()) break;

    if (!quiet) printf("\nLINE # %d\n",++ln_cnt);
    p = fgets(buff, BUFF_LEN, fin);
    //    printf(p);
    star = 0;
    n = sscanf(buff, "%1s %12[0-9] %*c %x %*c %x %*c %x %*c %n", &star, dt_str, &cpu_freq, &pulse_cnt, &interval, &char_cnt);
    //    printf("GOT %c (%x) %d\n",star,star,n);

    if (!quiet) {
      printf("[%d] %c ",n , star);
      printf("%14.14s", dt_str);
    }

    switch (star) {
    case '*' :
      garbage_cnt = 0;
      break;

    case '#' :

      garbage_cnt = 0;
      fputs(buff, fout);
      continue;
      break;
    default :
      ++garbage_cnt;
      continue;
      break;
    }


    if (!quiet)  printf(" %dKHz  #%d %d\n",cpu_freq, pulse_cnt, interval);
    
    n  = strncmp(dt_str, last_dt_str, 12);

    if (!n) ++dt_cnt; else dt_cnt = 0;

    strncpy(last_dt_str, dt_str,13);


    if (1) {
      double dt, pulse_freq;
      dt = interval / (double)cpu_freq;
      pulse_freq = pulse_cnt / dt;

      if (!quiet) printf("*%s.%d, %.3f, %.3f", dt_str, dt_cnt, pulse_freq, dt);
      if (fout) fprintf(fout, "*%s.%d, %.3f, %.3f", dt_str, dt_cnt, pulse_freq, dt);
    }

#if 1
    str_pos = char_cnt;
    do {
      double dt;
      
      n = sscanf(buff+str_pos, "%x %n", &interval, &char_cnt);
      if (n<1) break;

      //      printf("[%d %d] %d ",n,char_cnt, interval);
      //      printf("%d ",interval);

      dt = 16.0 * interval / (double)cpu_freq;
      if (!quiet)      printf(", %.3f", dt);
      if (fout)       fprintf(fout, ", %.3f", dt);

      str_pos += char_cnt;
    } while(n>0);

    
#endif
    if (!quiet)    printf("\n");

    if (fout) {
      if (trail_num) fprintf(fout, ", 9999");
      fprintf(fout, "\n\n");
    }

    //    if (ln_cnt++>10) break;
  }
  
  fclose(fin);
  if (fout) fclose(fout);
  return 0;
}
